/// <reference path="../lib/SpreadJS/definition/gcspread.sheets.d.ts"/>
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var AutoCompleteCellType = (function (_super) {
    __extends(AutoCompleteCellType, _super);
    function AutoCompleteCellType(availableTags) {
        _super.call(this);
        this.availableTags = [];
        if (availableTags && availableTags.length > 0) {
            this.availableTags = availableTags;
        }
    }
    AutoCompleteCellType.prototype.createEditorElement = function (context) {
        //Create input presenter.
        return document.createElement("input");
    };
    AutoCompleteCellType.prototype.activateEditor = function (editorContext, cellStyle, cellRect, context) {
        var $editor = $(editorContext);
        _super.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
        $editor.css("position", "absolute");
        $editor.attr("gcUIElement", "gcEditingInput");
        $editor.autocomplete({
            source: this.availableTags
        }); // initialize autocomplete widget
        $editor.autocomplete("widget").attr("gcUIElement", "gcEditingInput"); // keep focus when mouse down on dropdown
        return $editor;
    };
    AutoCompleteCellType.prototype.deactivateEditor = function (editorContext, context) {
        if (editorContext) {
            var $editor = $(editorContext);
            // $editor.autocomplete("hide");
            $editor.autocomplete("destroy");
        }
        _super.prototype.deactivateEditor.call(this, editorContext, context);
    };
    AutoCompleteCellType.prototype.setEditorValue = function (editorContext, value, context) {
        $(editorContext).val(value);
    };
    AutoCompleteCellType.prototype.getEditorValue = function (editorContext, context) {
        return $(editorContext).val();
    };
    AutoCompleteCellType.prototype.updateEditor = function (editorContext, cellStyle, cellRect, context) {
        if (editorContext) {
            var $editor = $(editorContext);
            $editor.css("width", cellRect.width);
            $editor.css("height", cellRect.height);
        }
    };
    AutoCompleteCellType.prototype.isReservedKey = function (event, context) {
        if (context.isEditing && (event.keyCode == 40 || event.keyCode == 38)) {
            return true;
        }
        return false;
    };
    AutoCompleteCellType.prototype.setAutocompleteSource = function (source) {
        this.availableTags = source;
    };
    AutoCompleteCellType.prototype.getAutocompleteSource = function () {
        return this.availableTags;
    };
    return AutoCompleteCellType;
}(GcSpread.Sheets.CustomCellType));
//# sourceMappingURL=AutoCompleteCellType.js.map