
/// <reference path="../lib/SpreadJS/definition/gcspread.sheets.d.ts"/>
// http://jqueryui.com/autocomplete/
declare var $;

class AutoCompleteCellType extends GcSpread.Sheets.CustomCellType {
    availableTags = [
    ];
    constructor(availableTags: Array<string>) {
        super();
        if (availableTags && availableTags.length > 0) {
            this.availableTags = availableTags;
        }
    }

    createEditorElement(context) {
        //Create input presenter.
        return document.createElement("input");
    }

    activateEditor(editorContext: any, cellStyle: GcSpread.Sheets.Style, cellRect: GcSpread.Sheets.Rect, context?: any) {
        var $editor = $(editorContext);
        super.activateEditor(editorContext, cellStyle, cellRect, context);
        $editor.css("position", "absolute");
        $editor.attr("gcUIElement", "gcEditingInput");
        $editor.autocomplete({
            source: this.availableTags
        }); // initialize autocomplete widget
        $editor.autocomplete("widget").attr("gcUIElement", "gcEditingInput"); // keep focus when mouse down on dropdown
        return $editor;
    }

    deactivateEditor(editorContext: any, context?: any) {
        if (editorContext) {
            var $editor = $(editorContext);
            // $editor.autocomplete("hide");
            $editor.autocomplete("destroy");
        }

        super.deactivateEditor(editorContext, context);
    }

    setEditorValue(editorContext: any, value: any, context?: any) {
        $(editorContext).val(value);
    }

    getEditorValue(editorContext: any, context?: any) {
        return $(editorContext).val();
    }

    updateEditor(editorContext: any, cellStyle: GcSpread.Sheets.Style, cellRect: GcSpread.Sheets.Rect, context?: any) {
        if (editorContext) {
            var $editor = $(editorContext);
            $editor.css("width", cellRect.width);
            $editor.css("height", cellRect.height);
        }
    }


    isReservedKey(event: KeyboardEvent, context?: any): boolean {
        if (context.isEditing && (event.keyCode == 40 || event.keyCode == 38)) { // reserve up/down key to select items
            return true;
        }
        return false;
    }

    setAutocompleteSource(source: Array<string>) {
        this.availableTags = source;
    }
    getAutocompleteSource(): Array<string> {
        return this.availableTags;
    }

}